# coding=utf-8
# *** WARNING: this file was generated by pulumigen. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 api_key: Optional[pulumi.Input[str]] = None,
                 client_id: Optional[pulumi.Input[str]] = None,
                 client_secret: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] api_key: The Tailscale API key.
        :param pulumi.Input[str] client_id: The Tailscale OAuth client ID.
        :param pulumi.Input[str] client_secret: The Tailscale OAuth client secret.
        """
        if api_key is None:
            api_key = _utilities.get_env('TAILSCALE_NATIVE_APIKEY', 'TAILSCALE_APIKEY')
        if api_key is not None:
            pulumi.set(__self__, "api_key", api_key)
        if client_id is None:
            client_id = _utilities.get_env('TAILSCALE_NATIVE_CLIENT_ID', 'TAILSCALE_CLIENT_ID')
        if client_id is not None:
            pulumi.set(__self__, "client_id", client_id)
        if client_secret is None:
            client_secret = _utilities.get_env('TAILSCALE_NATIVE_CLIENT_SECRET', 'TAILSCALE_CLIENT_SECRET')
        if client_secret is not None:
            pulumi.set(__self__, "client_secret", client_secret)

    @property
    @pulumi.getter(name="apiKey")
    def api_key(self) -> Optional[pulumi.Input[str]]:
        """
        The Tailscale API key.
        """
        return pulumi.get(self, "api_key")

    @api_key.setter
    def api_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_key", value)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> Optional[pulumi.Input[str]]:
        """
        The Tailscale OAuth client ID.
        """
        return pulumi.get(self, "client_id")

    @client_id.setter
    def client_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_id", value)

    @property
    @pulumi.getter(name="clientSecret")
    def client_secret(self) -> Optional[pulumi.Input[str]]:
        """
        The Tailscale OAuth client secret.
        """
        return pulumi.get(self, "client_secret")

    @client_secret.setter
    def client_secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_secret", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 client_id: Optional[pulumi.Input[str]] = None,
                 client_secret: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The provider type for the Tailscale package.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_key: The Tailscale API key.
        :param pulumi.Input[str] client_id: The Tailscale OAuth client ID.
        :param pulumi.Input[str] client_secret: The Tailscale OAuth client secret.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the Tailscale package.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_key: Optional[pulumi.Input[str]] = None,
                 client_id: Optional[pulumi.Input[str]] = None,
                 client_secret: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            if api_key is None:
                api_key = _utilities.get_env('TAILSCALE_NATIVE_APIKEY', 'TAILSCALE_APIKEY')
            __props__.__dict__["api_key"] = None if api_key is None else pulumi.Output.secret(api_key)
            if client_id is None:
                client_id = _utilities.get_env('TAILSCALE_NATIVE_CLIENT_ID', 'TAILSCALE_CLIENT_ID')
            __props__.__dict__["client_id"] = client_id
            if client_secret is None:
                client_secret = _utilities.get_env('TAILSCALE_NATIVE_CLIENT_SECRET', 'TAILSCALE_CLIENT_SECRET')
            __props__.__dict__["client_secret"] = None if client_secret is None else pulumi.Output.secret(client_secret)
        super(Provider, __self__).__init__(
            'tailscale-native',
            resource_name,
            __props__,
            opts)

